//+------------------------------------------------------------------+
//| 01  2009 .                                  Fractals9tf.mq4 |
//+------------------------------------------------------------------+
/*

        
      
         

  -  . 
          -    . 
  -   ,  -  ,  -  ,  -    ...  .

   ,    .   9 .



showZigZag -   
showZigZag = 0 -  ,      . 
                      .  .

showZigZag = 1 -  ,      . 
                      .

showZigZag = 2 -        . 

showZigZag = 3 -  ,      .
                           .

showZigZag = 4 -     . 
                           .

showZigZag = 5 -     . 
                        ,    ,
                      ,   DT-ZigZag

showZigZag = 6 -  ,      .
                        ,    ,
                      ,   DT-ZigZag

ExtBarLeft > 0 -      
ExtBarRight> 0 -      

ExtMaxBar -  ,     . -    .
                       .
GrossPeriod -  ,   ,      .
zzVisible 0 -         , 1 -  .
zzColor  -     .
extColor -  ,           .

ExtProcedureOfPayments -   : true -    , false -   .

ExtZZ -      (      ),
          ExtZZ = - true       ,
        ExtZZ = false -       

*/

#property copyright "nen"
//#property link      "http://"

#property indicator_chart_window
//    
#property indicator_buffers  8

//---- input parameters
extern string showZigZag   = "0,0,0,0,0,0,0,0,0";
//extern string showZigZag   = "1,1,1,0,1,1,1,1,1";
//extern string showZigZag   = "2,2,2,2,2,2,2,2,2";
//extern string showZigZag   = "3,3,3,3,3,3,3,3,3";
//extern string showZigZag   = "4,4,4,4,4,4,4,4,4";
//extern string showZigZag   = "5,5,5,5,5,5,5,5,5";

extern string ExtBarLeft   = "3,3,3,3,3,3,3,3,3";
extern string ExtBarRight  = "3,3,3,3,3,3,3,3,3";

extern string ExtMaxBar    = "5000,1000,350,350,350,350,350,350,350,350";   //    (0-)
extern string GrossPeriod  = "1,5,15,30,60,240,1440,10080,43200";      // ,     .
extern string zzVisible    = "1,1,1,0,1,1,1,1,1";
//                            1     5        15       30      60  240     1440   10080   43200
extern string zzColor      = "Tan,RoyalBlue,Aqua,SaddleBrown,Red,Yellow,Magenta,Purple,MediumSpringGreen";
extern string extColor     = "Indigo,Olive,Teal";
extern bool   ExtProcedureOfPayments = false;

extern bool   ExtZZ        = true;
//extern int       ExtComplet = 0;

//   
double LB1[],HB1[],LB2[],HB2[],LB3[],HB3[],LB4[],HB4[];
//   
double LBG1[],HBG1[],LBG2[],HBG2[],LBG3[],HBG3[],LBG4[],HBG4[],LBG5[],HBG5[],LBG6[],HBG6[],LBG7[],HBG7[],LBG8[],HBG8[],LBG9[],HBG9[];

int showZigZag_[]={0,0,0,0,0,0,0,0,0}, ExtBarLeft_[]={0,0,0,0,0,0,0,0,0}, ExtBarRight_[]={0,0,0,0,0,0,0,0,0}, ExtMaxBar_[]={0,0,0,0,0,0,0,0,0}, GrossPeriod_[]={0,0,0,0,0,0,0,0,0}, zzVisible_[]={0,0,0,0,0,0,0,0,0};
int zzColor_[]={0,0,0,0,0,0,0,0,0}, extColor_[]={0,0,0}, currentBars_[]={0,0,0,0,0,0,0,0,0};

//  , ,       
bool Grosstf_DT[]={false, false, false, false, false, false, false, false, false};

datetime tlastfractal_[]={0,0,0,0,0,0,0,0,0};

//       lBar, hBar  tiZZ   
//             . 
//        .
double lBar[]={0,0,0,0,0,0,0,0,0}, hBar[]={0,0,0,0,0,0,0,0,0};
datetime tiZZ[]={0,0,0,0,0,0,0,0,0};
//      Bars
int saveBars[]={0,0,0,0,0,0,0,0,0};
int currentBars;
//       .     .
int ProcedureOfPayments[9][3];
//  ,   ,     
int limit;

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
   int i,j,k,n,q;

//            
   SetIndexBuffer(0,LB1);
   SetIndexBuffer(1,HB1);
   SetIndexBuffer(2,LB2);
   SetIndexBuffer(3,HB2);
   SetIndexBuffer(4,LB3);
   SetIndexBuffer(5,HB3);
   SetIndexBuffer(6,LB4);
   SetIndexBuffer(7,HB4);

//   ,      
   SetIndexEmptyValue(0,0.0);
   SetIndexEmptyValue(1,0.0);
   SetIndexEmptyValue(2,0.0);
   SetIndexEmptyValue(3,0.0);
   SetIndexEmptyValue(4,0.0);
   SetIndexEmptyValue(5,0.0);
   SetIndexEmptyValue(6,0.0);
   SetIndexEmptyValue(7,0.0);

//        
   SetIndexLabel(0,"Low1" );
   SetIndexLabel(1,"High1");
   SetIndexLabel(2,"Low2" );
   SetIndexLabel(3,"High2");
   SetIndexLabel(4,"Low3" );
   SetIndexLabel(5,"High3");
   SetIndexLabel(6,"Low4" );
   SetIndexLabel(7,"High4");

   _stringtointarray (showZigZag,   showZigZag_,  9);
   _stringtointarray (ExtBarLeft,   ExtBarLeft_,  9);
   _stringtointarray (ExtBarRight,  ExtBarRight_, 9);
   _stringtointarray (ExtMaxBar,    ExtMaxBar_,   9);
   _stringtointarray (GrossPeriod,  GrossPeriod_, 9);
   _stringtointarray (zzVisible,    zzVisible_,   9);
   _stringtocolorarray (zzColor,    zzColor_,     9);
   _stringtocolorarray (extColor,   extColor_,    3);

   for (i=0;i<9;i++)
     {
      Grosstf_DT[i]=false;
      if (GrossPeriod_[i]<Period()) GrossPeriod_[i]=0;

      if (GrossPeriod_[i]==0) zzVisible_[i]=0;
      if (zzVisible_[i]>0 && GrossPeriod_[i]>Period())
        {
         if ((ExtMaxBar_[i]>iBars(NULL,GrossPeriod_[i])-ExtBarLeft_[i]) || (ExtMaxBar_[i]==0)) limit=iBars(NULL,GrossPeriod_[i])- ExtBarLeft_[i]; else limit=ExtMaxBar_[i];

         if (i==0)      arr_resize(LBG1, HBG1, limit+ExtBarLeft_[i], i);
         else if (i==1) arr_resize(LBG2, HBG2, limit+ExtBarLeft_[i], i);
         else if (i==2) arr_resize(LBG3, HBG3, limit+ExtBarLeft_[i], i);
         else if (i==3) arr_resize(LBG4, HBG4, limit+ExtBarLeft_[i], i);
         else if (i==4) arr_resize(LBG5, HBG5, limit+ExtBarLeft_[i], i);
         else if (i==5) arr_resize(LBG6, HBG6, limit+ExtBarLeft_[i], i);
         else if (i==6) arr_resize(LBG7, HBG7, limit+ExtBarLeft_[i], i);
         else if (i==7) arr_resize(LBG8, HBG8, limit+ExtBarLeft_[i], i);
         else if (i==8) arr_resize(LBG9, HBG9, limit+ExtBarLeft_[i], i);
        }

      ProcedureOfPayments[i][0]=GrossPeriod_[i];
      ProcedureOfPayments[i][1]=i;
     }

   ArraySort(ProcedureOfPayments,WHOLE_ARRAY,0,MODE_ASCEND);

   j=1;k=0;q=-1;
   for (n=0;n<9;n++)
     {
      i=ProcedureOfPayments[n][1];
      if (ExtBarLeft_[i]<0) ExtBarLeft_[i]=1;
      if (ExtBarRight_[i]<0) ExtBarRight_[i]=1;

      if (showZigZag_[i]<0) showZigZag_[i]=0;
      if (showZigZag_[i]>6) showZigZag_[i]=6;

      if (zzVisible_[i]==0 || j>4) ProcedureOfPayments[n][2]=0;
      else if (GrossPeriod_[i]>0)
        {
         if (ProcedureOfPayments[n][0]==q)
           {
            zzColor_[i]=extColor_[k];
            k++;
           }

         q=ProcedureOfPayments[n][0];

         if (j==1)
           {
            if (showZigZag_[i]==0)
              {
               SetIndexStyle(0,DRAW_ZIGZAG, EMPTY, 0, zzColor_[i]);
               SetIndexStyle(1,DRAW_ZIGZAG, EMPTY, 0, zzColor_[i]);
              }
            else if  (showZigZag_[i]==1 || showZigZag_[i]==2)
              {
               SetIndexStyle(0,DRAW_ARROW, EMPTY, 0, zzColor_[i]);
               SetIndexArrow(0,116);
               SetIndexStyle(1,DRAW_ARROW, EMPTY, 0, zzColor_[i]);
               SetIndexArrow(1,116);
              }
            else if (showZigZag_[i]==3 || showZigZag_[i]==4)
              {
               SetIndexStyle(0,DRAW_SECTION, EMPTY, 0, zzColor_[i]);
               SetIndexStyle(1,DRAW_SECTION, EMPTY, 0, zzColor_[i]);
              }
            else if  (showZigZag_[i]==5 || showZigZag_[i]==6)
              {
               SetIndexStyle(0,DRAW_ARROW, EMPTY, 0, zzColor_[i]);
               SetIndexArrow(0,159);
               SetIndexStyle(1,DRAW_ARROW, EMPTY, 0, zzColor_[i]);
               SetIndexArrow(1,159);
              }
           }
         else if (j==2)
           {
            if (showZigZag_[i]==0)
              {
               SetIndexStyle(2,DRAW_ZIGZAG, EMPTY, 0, zzColor_[i]);
               SetIndexStyle(3,DRAW_ZIGZAG, EMPTY, 0, zzColor_[i]);
              }
            else if  (showZigZag_[i]==1 || showZigZag_[i]==2)
              {
               SetIndexStyle(2,DRAW_ARROW, EMPTY, 0, zzColor_[i]);
               SetIndexArrow(2,116);
               SetIndexStyle(3,DRAW_ARROW, EMPTY, 0, zzColor_[i]);
               SetIndexArrow(3,116);
              }
            else if (showZigZag_[i]==3 || showZigZag_[i]==4)
              {
               SetIndexStyle(2,DRAW_SECTION, EMPTY, 0, zzColor_[i]);
               SetIndexStyle(3,DRAW_SECTION, EMPTY, 0, zzColor_[i]);
              }
            else if  (showZigZag_[i]==5 || showZigZag_[i]==6)
              {
               SetIndexStyle(2,DRAW_ARROW, EMPTY, 0, zzColor_[i]);
               SetIndexArrow(2,159);
               SetIndexStyle(3,DRAW_ARROW, EMPTY, 0, zzColor_[i]);
               SetIndexArrow(3,159);
              }
           }
         else if (j==3)
           {
            if (showZigZag_[i]==0)
              {
               SetIndexStyle(4,DRAW_ZIGZAG, EMPTY, 0, zzColor_[i]);
               SetIndexStyle(5,DRAW_ZIGZAG, EMPTY, 0, zzColor_[i]);
              }
            else if  (showZigZag_[i]==1 || showZigZag_[i]==2)
              {
               SetIndexStyle(4,DRAW_ARROW, EMPTY, 0, zzColor_[i]);
               SetIndexArrow(4,116);
               SetIndexStyle(5,DRAW_ARROW, EMPTY, 0, zzColor_[i]);
               SetIndexArrow(5,116);
              }
            else if (showZigZag_[i]==3 || showZigZag_[i]==4)
              {
               SetIndexStyle(4,DRAW_SECTION, EMPTY, 0, zzColor_[i]);
               SetIndexStyle(5,DRAW_SECTION, EMPTY, 0, zzColor_[i]);
              }
            else if  (showZigZag_[i]==5 || showZigZag_[i]==6)
              {
               SetIndexStyle(4,DRAW_ARROW, EMPTY, 0, zzColor_[i]);
               SetIndexArrow(4,159);
               SetIndexStyle(5,DRAW_ARROW, EMPTY, 0, zzColor_[i]);
               SetIndexArrow(5,159);
              }
           }
         else if (j==4)
           {
            if (showZigZag_[i]==0)
              {
               SetIndexStyle(6,DRAW_ZIGZAG, EMPTY, 0, zzColor_[i]);
               SetIndexStyle(7,DRAW_ZIGZAG, EMPTY, 0, zzColor_[i]);
              }
            else if  (showZigZag_[i]==1 || showZigZag_[i]==2)
              {
               SetIndexStyle(6,DRAW_ARROW, EMPTY, 0, zzColor_[i]);
               SetIndexArrow(6,116);
               SetIndexStyle(7,DRAW_ARROW, EMPTY, 0, zzColor_[i]);
               SetIndexArrow(7,116);
              }
            else if (showZigZag_[i]==3 || showZigZag_[i]==4)
              {
               SetIndexStyle(6,DRAW_SECTION, EMPTY, 0, zzColor_[i]);
               SetIndexStyle(7,DRAW_SECTION, EMPTY, 0, zzColor_[i]);
              }
            else if  (showZigZag_[i]==5 || showZigZag_[i]==6)
              {
               SetIndexStyle(6,DRAW_ARROW, EMPTY, 0, zzColor_[i]);
               SetIndexArrow(6,159);
               SetIndexStyle(7,DRAW_ARROW, EMPTY, 0, zzColor_[i]);
               SetIndexArrow(7,159);
              }
           }
         ProcedureOfPayments[n][2]=j; j++;
        }

     }

   if (ExtProcedureOfPayments) ArraySort(ProcedureOfPayments,WHOLE_ARRAY,0,MODE_ASCEND); else ArraySort(ProcedureOfPayments,WHOLE_ARRAY,0,MODE_DESCEND);

   currentBars=0;
   return(0);
  }

//+------------------------------------------------------------------+
//| Custom indicator deinitialization function. .              |
//+------------------------------------------------------------------+
int deinit()
  {
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function. .               |
//+------------------------------------------------------------------+

//+------------------------------------------------------------------+
//|  . .                                       |
//+------------------------------------------------------------------+
int start()
  {
   int i,j,n;
   bool calculate;

   if (currentBars<Bars-1)
     {
      for (n=0;n<9;n++)
        {
         if (ProcedureOfPayments[n][2]>0) {i=ProcedureOfPayments[n][1]; saveBars[i]=0; currentBars_[i]=0;}
        }
     }

   currentBars=Bars;

   for (n=0;n<9;n++)
     {
      i=ProcedureOfPayments[n][1];

      if (zzVisible_[i]==0) continue;

      if (iBars(NULL, GrossPeriod_[i])-currentBars_[i]>1) {saveBars[i]=0;}
      currentBars_[i]=iBars(NULL, GrossPeriod_[i]);

      calculate=false;

      if (limit>2)
        {
         calculate=true;
         Grosstf_DT[i]=false;

         if ((ExtMaxBar_[i]>iBars(NULL,GrossPeriod_[i])-ExtBarLeft_[i]) || (ExtMaxBar_[i]==0)) limit=iBars(NULL,GrossPeriod_[i])- ExtBarLeft_[i]; else limit=ExtMaxBar_[i];

         if (GrossPeriod_[i]>Period())
           {
            if (i==0)      arr_resize(LBG1, HBG1, limit+ExtBarLeft_[i], i);
            else if (i==1) arr_resize(LBG2, HBG2, limit+ExtBarLeft_[i], i);
            else if (i==2) arr_resize(LBG3, HBG3, limit+ExtBarLeft_[i], i);
            else if (i==3) arr_resize(LBG4, HBG4, limit+ExtBarLeft_[i], i);
            else if (i==4) arr_resize(LBG5, HBG5, limit+ExtBarLeft_[i], i);
            else if (i==5) arr_resize(LBG6, HBG6, limit+ExtBarLeft_[i], i);
            else if (i==6) arr_resize(LBG7, HBG7, limit+ExtBarLeft_[i], i);
            else if (i==7) arr_resize(LBG8, HBG8, limit+ExtBarLeft_[i], i);
            else if (i==8) arr_resize(LBG9, HBG9, limit+ExtBarLeft_[i], i);
           }

         if (ProcedureOfPayments[n][2]==1)
           {
            ArrayInitialize(LB1,0); ArrayInitialize(HB1,0);
           }
         else if (ProcedureOfPayments[n][2]==2)
           {
            ArrayInitialize(LB2,0); ArrayInitialize(HB2,0); 
           }
         else if (ProcedureOfPayments[n][2]==3)
           {
            ArrayInitialize(LB3,0); ArrayInitialize(HB3,0); 
          }
         else if (ProcedureOfPayments[n][2]==4)
           {
            ArrayInitialize(LB4,0); ArrayInitialize(HB4,0); 
          }

         tlastfractal_[i]=0;

        }
      else
        {
         if (lBar[i]>iLow(NULL,GrossPeriod_[i],0) || hBar[i]<iHigh(NULL,GrossPeriod_[i],0) || tiZZ[i]!=iTime(NULL,GrossPeriod_[i],0))
           {
            calculate=true;
           }
        }

      if (calculate)
        {

         if (i==0)      _Gross(LBG1, HBG1, limit, n);
         else if (i==1) _Gross(LBG2, HBG2, limit, n);
         else if (i==2) _Gross(LBG3, HBG3, limit, n);
         else if (i==3) _Gross(LBG4, HBG4, limit, n);
         else if (i==4) _Gross(LBG5, HBG5, limit, n);
         else if (i==5) _Gross(LBG6, HBG6, limit, n);
         else if (i==6) _Gross(LBG7, HBG7, limit, n);
         else if (i==7) _Gross(LBG8, HBG8, limit, n);
         else if (i==8) _Gross(LBG9, HBG9, limit, n);

        }

     }

 //   
   return(0);
  }
//+------------------------------------------------------------------+
//|  . .                                        |
//+------------------------------------------------------------------+

//+------------------------------------------------------------------+
//+------------------------------------------------------------------+
//|                                              |
//+------------------------------------------------------------------+
//+------------------------------------------------------------------+

//+------------------------------------------------------------------+
//|     Grossperiod. .                 |
//+------------------------------------------------------------------+

int _Gross(double& GLB[],double& GHB[],int limit,int n)
  {
   int x=ProcedureOfPayments[n][1];

   if (GrossPeriod_[x]==Period())
    {
     if      (ProcedureOfPayments[n][2]==1) Fractals_(LB1, HB1, x);
     else if (ProcedureOfPayments[n][2]==2) Fractals_(LB2, HB2, x);
     else if (ProcedureOfPayments[n][2]==3) Fractals_(LB3, HB3, x);
     else if (ProcedureOfPayments[n][2]==4) Fractals_(LB4, HB4, x);
     else
      {
       if (limit==2) Shift_elements(GLB,GHB);
       Fractals_(GLB, GHB, x);
      }
    }
   else
    {
     if (limit==2) Shift_elements(GLB,GHB);
     if (Fractals_(GLB, GHB, x)==0)
       {
        if      (ProcedureOfPayments[n][2]==1) FractalsDT_(LB1, HB1, GLB, GHB, x);
        else if (ProcedureOfPayments[n][2]==2) FractalsDT_(LB2, HB2, GLB, GHB, x);
        else if (ProcedureOfPayments[n][2]==3) FractalsDT_(LB3, HB3, GLB, GHB, x);
        else if (ProcedureOfPayments[n][2]==4) FractalsDT_(LB4, HB4, GLB, GHB, x);
//Print ("GrossPeriod_["+x+"] = ",GrossPeriod_[x]);
       }
    }

   return(0);
  }
//+------------------------------------------------------------------+
//|     Grossperiod. .                  |
//+------------------------------------------------------------------+


//+------------------------------------------------------------------+
//|   . .                                        |
//+------------------------------------------------------------------+
int Fractals_(double& LB[],double& HB[],int x)
  {
   int i, bar;

//   if (tlastfractal_[x]>0) bar=iBarShift(NULL,GrossPeriod_[x],tlastfractal_[x],true); else bar=ArraySize(LB);

   if (tlastfractal_[x]>0)
     {
      //----    .    ,  .
      if (first_fractal(LB,HB,x)<0) return (-1);
     }
   else
     {
      //----  .     
      SamplingCreation(LB,HB,x);
     }

   if (showZigZag_[x]==0 || showZigZag_[x]==1 || showZigZag_[x]==3 || showZigZag_[x]==6)
     {
      //----  . 
      Weeding(LB,HB,x);
     }

   if (tlastfractal_[x]>0)
     {
      bar=iBarShift(NULL,GrossPeriod_[x],tlastfractal_[x],true);
      for (i=1;i<bar-1;i++)
        {
         if (LB[i]>0 || HB[i]>0) {tlastfractal_[x]=iTime(NULL,GrossPeriod_[x],i); break;}
        }
     }

   return(0);
  }
//+------------------------------------------------------------------+
//|   . .                                         |
//+------------------------------------------------------------------+


//+------------------------------------------------------------------+
//|       . |
//+------------------------------------------------------------------+
int FractalsDT_(double& LB[],double& HB[],double& GLB[],double& GHB[],int x)
  {
   int i=0, j, jl, jh, ext3=0, end, k;
   double el=-1, eh=-1;
   datetime t1, t2, t3=Period()*60-1;
   bool tdelta=false;

   if (Grosstf_DT[x]) //   .
     {
      end=iBarShift(NULL,GrossPeriod_[x],iTime(NULL, GrossPeriod_[x],tlastfractal_[x]),true)+1;

      t1=iTime(NULL, GrossPeriod_[x],i);
      for (j=0;ext3<end && j<Bars;j++)
        {

         if (Period()==10080)
           {
            if (el<0 && eh<0) tdelta=Time[j]<t1;
            else tdelta=Time[j]+t3<t1;
           }
         else
           {
            tdelta=Time[j]<t1;
           }

         if (tdelta) {i++; if (showZigZag_[x]==5 || showZigZag_[x]==6) {t2=t1+GrossPeriod_[x]*60;} t1=iTime(NULL, GrossPeriod_[x],i);}

         LB[j]=0;
         HB[j]=0;
         if (GLB[i]>0)
           {
            if (el>=Low[j] || el<0) {el=Low[j]; jl=j;}
           }
         else
           {
            if (el>0)
              {
               if (showZigZag_[x]==5 || showZigZag_[x]==6)
                 {
                  for (k=j-1;Time[k]<t2;k--)
                    {
                     if (k<0) break;
                     LB[k]=el;
                    }
                 }

               LB[jl]=el; el=-1; ext3++;
              }
           }

         if  (GHB[i]>0)
           {
            if (eh<=High[j]) {eh=High[j]; jh=j;}
           }
         else
           {
            if (eh>0)
              {
               if (showZigZag_[x]==5 || showZigZag_[x]==6)
                 {
                  for (k=j-1;Time[k]<t2;k--)
                    {
                     if (k<0) break;
                     HB[k]=eh;
                    }
                 }

               HB[jh]=eh; eh=-1; ext3++;
              }
           } 

        }
     }
   else //    .
     {
      end=iBarShift(NULL,Period(),iTime(NULL, GrossPeriod_[x],ArraySize(GLB)),false);

      if (end<=0) {saveBars[x]=0; return (-1);}

      Grosstf_DT[x]=true;

      t1=iTime(NULL, GrossPeriod_[x],i);
      for (j=0;j<end;j++)
        {

         if (Period()==10080)
           {
            if (el<0 && eh<0) tdelta=Time[j]<t1;
            else tdelta=Time[j]+t3<t1;
           }
         else
           {
            tdelta=Time[j]<t1;
           }

         if (tdelta) {i++; if (showZigZag_[x]==5 || showZigZag_[x]==6) {t2=t1+GrossPeriod_[x]*60;} t1=iTime(NULL, GrossPeriod_[x],i);}

         if (GLB[i]>0)
           {
            if (el>=Low[j] || el<0) {el=Low[j]; jl=j;}
           }
         else
           {
            if (el>0)
              {
               if (showZigZag_[x]==5 || showZigZag_[x]==6)
                 {
                  for (k=j-1;Time[k]<t2;k--)
                    {
                     if (k<0) break;
                     LB[k]=el;
                    }
                 }

               LB[jl]=el; el=-1;
              }
           }

         if  (GHB[i]>0)
           {
            if (eh<=High[j]) {eh=High[j]; jh=j;}
           }
         else
           {
            if (eh>0)
              {
               if (showZigZag_[x]==5 || showZigZag_[x]==6)
                 {
                  for (k=j-1;Time[k]<t2;k--)
                    {
                     if (k<0) break;
                     HB[k]=eh;
                    }
                 }

               HB[jh]=eh; eh=-1;
              }
           } 
        }
     }

   return (0);
  }
//+------------------------------------------------------------------+
//|       . .|
//+------------------------------------------------------------------+


//+------------------------------------------------------------------+
//|      . .               |
//+------------------------------------------------------------------+
int first_fractal(double& LB[],double& HB[],int x)
  {
   int i, j, k, lastlowpos, lasthighpos, bar;
   bool frl=false, frh=false, retl=false, reth=false, ret=false, ret_l=false, ret_h=false;
   double lastlow=0, lasthigh=0;

   bar=iBarShift(NULL,GrossPeriod_[x],tlastfractal_[x],true);

//---- low
   for (i=2;i<bar-2;i++)
     {

      if (!frl)
        {
         if (iLow(NULL,GrossPeriod_[x],i)<iLow(NULL,GrossPeriod_[x],i-1)) {frl=true; lastlow=iLow(NULL,GrossPeriod_[x],i); lastlowpos=i;}
        }
       else
        {
         if (lastlow<iLow(NULL,GrossPeriod_[x],i))
           {
            k=ExtBarLeft_[x];
            for (j=lastlowpos+1;(j<bar-1 && k>0);j++)
              {
               if (iLow(NULL,GrossPeriod_[x],j)==lastlow) {k=ExtBarLeft_[x]; continue;}
               if (iLow(NULL,GrossPeriod_[x],j)<lastlow && k>0) {frl=false; break;}
               if (iLow(NULL,GrossPeriod_[x],j)>lastlow) k--;
              }

            if (frl)
              {
               k=ExtBarRight_[x];
               for (j=lastlowpos-1;(j>0 && k>0);j--)
                 {
                  if (j==1 && k>1) {frl=false; break;}
                  if (iLow(NULL,GrossPeriod_[x],j)==lastlow) {k=ExtBarRight_[x]; continue;}
                  if (iLow(NULL,GrossPeriod_[x],j)<lastlow && k>0) {frl=false; break;}
                  if (iLow(NULL,GrossPeriod_[x],j)>lastlow) k--;
                 }
              }

            if (frl) LB[lastlowpos]=lastlow;
            frl=false;

            if (!retl && !ret) {if (tlastfractal_[x]==iTime(NULL,GrossPeriod_[x],lastlowpos)) retl=true; else {tlastfractal_[x]=iTime(NULL,GrossPeriod_[x],lastlowpos); ret=true;}}
            else if (retl || ret) ret_l=true;
           }
         else
           {
            if (ExtZZ)
              {
               if (lastlow>=iLow(NULL,GrossPeriod_[x],i)) {lastlow=iLow(NULL,GrossPeriod_[x],i); lastlowpos=i;}
              }
            else
              {
               if (lastlow>iLow(NULL,GrossPeriod_[x],i)) {lastlow=iLow(NULL,GrossPeriod_[x],i); lastlowpos=i;}
              }
           }
        }    
         
//---- high
      if (!frh)
        {
         if (iHigh(NULL,GrossPeriod_[x],i)>iHigh(NULL,GrossPeriod_[x],i-1)) {frh=true; lasthigh=iHigh(NULL,GrossPeriod_[x],i); lasthighpos=i;}
        }
       else
        {
         if (lasthigh>iHigh(NULL,GrossPeriod_[x],i))
           {
            k=ExtBarLeft_[x];
            for (j=lasthighpos+1;(j<bar-1 && k>0);j++)
              {
               if (iHigh(NULL,GrossPeriod_[x],j)==lasthigh) {k=ExtBarLeft_[x]; continue;}
               if (iHigh(NULL,GrossPeriod_[x],j)>lasthigh && k>0) {frh=false; break;}
               if (iHigh(NULL,GrossPeriod_[x],j)<lasthigh) k--;
              }

            if (frh)
              {
               k=ExtBarRight_[x];
               for (j=lasthighpos-1;(j>0 && k>0);j--)
                 {
                  if (j==1 && k>1) {frh=false; break;}
                  if (iHigh(NULL,GrossPeriod_[x],j)==lasthigh) {k=ExtBarRight_[x]; continue;}
                  if (iHigh(NULL,GrossPeriod_[x],j)>lasthigh && k>0) {frh=false; break;}
                  if (iHigh(NULL,GrossPeriod_[x],j)<lasthigh) k--;
                 }
              }

            if (frh) HB[lasthighpos]=lasthigh;
            frh=false;

            if (!reth && !ret) if (tlastfractal_[x]==iTime(NULL,GrossPeriod_[x],lasthighpos)) reth=true; else {tlastfractal_[x]=iTime(NULL,GrossPeriod_[x],lasthighpos); ret=true;}
            else if (retl || ret) ret_h=true;
           }
         else
           {
            if (ExtZZ)
              {
               if (lasthigh<=iHigh(NULL,GrossPeriod_[x],i)) {lasthigh=iHigh(NULL,GrossPeriod_[x],i); lasthighpos=i;}
              }
            else
              {
               if (lasthigh<iHigh(NULL,GrossPeriod_[x],i)) {lasthigh=iHigh(NULL,GrossPeriod_[x],i); lasthighpos=i;}
              }
           }
        }

      if (ret_l && ret_h)
         {
          if (retl || reth) return (-1);
          if (ret) return (0);
         }

     }
  }
//+------------------------------------------------------------------+
//|      . .                |
//+------------------------------------------------------------------+


//+------------------------------------------------------------------+
//|    . .                             |
//+------------------------------------------------------------------+
int SamplingCreation(double& LB[],double& HB[],int x)
  {
   int i, j, k, lastlowpos, lasthighpos, bar;
   bool frl=false, frh=false;
   double lastlow, lasthigh;

   bar=ArraySize(LB);

//---- low
   for (i=bar-2;i>0;i--)
     {
      if (!frl)
        {
         if (iLow(NULL,GrossPeriod_[x],i)<iLow(NULL,GrossPeriod_[x],i+1)) {frl=true; lastlowpos=i; lastlow=iLow(NULL,GrossPeriod_[x],i);}
        }
       else
        {
         if (lastlow<iLow(NULL,GrossPeriod_[x],i))
           {
            k=ExtBarLeft_[x];
            for (j=lastlowpos+1;(j<bar-1 && k>0);j++)
              {
               if (iLow(NULL,GrossPeriod_[x],j)==lastlow) {k=ExtBarLeft_[x]; continue;}
               if (iLow(NULL,GrossPeriod_[x],j)<lastlow && k>0) {frl=false; break;}
               if (iLow(NULL,GrossPeriod_[x],j)>lastlow) k--;
              }

            if (frl)
              {
               k=ExtBarRight_[x];
               for (j=lastlowpos-1;(j>0 && k>0);j--)
                 {
                  if (j==1 && k>1) {frl=false; break;}
                  if (iLow(NULL,GrossPeriod_[x],j)==lastlow) {k=ExtBarRight_[x]; continue;}
                  if (iLow(NULL,GrossPeriod_[x],j)<lastlow && k>0) {frl=false; break;}
                  if (iLow(NULL,GrossPeriod_[x],j)>lastlow) k--;
                 }
              }

            if (frl) LB[lastlowpos]=lastlow;
            frl=false;
           }
         else
           {
            if (ExtZZ)
              {
               if (lastlow>iLow(NULL,GrossPeriod_[x],i)) {lastlow=iLow(NULL,GrossPeriod_[x],i); lastlowpos=i;}
              }
            else
              {
               if (lastlow>=iLow(NULL,GrossPeriod_[x],i)) {lastlow=iLow(NULL,GrossPeriod_[x],i); lastlowpos=i;}
              }
           }
        }    

//---- high
      if (!frh)
        {
         if (iHigh(NULL,GrossPeriod_[x],i)>iHigh(NULL,GrossPeriod_[x],i+1)) {frh=true; lasthighpos=i; lasthigh=iHigh(NULL,GrossPeriod_[x],i);}
        }
       else
        {
         if (lasthigh>iHigh(NULL,GrossPeriod_[x],i))
           {
            k=ExtBarLeft_[x];
            for (j=lasthighpos+1;(j<bar-1 && k>0);j++)
              {
               if (iHigh(NULL,GrossPeriod_[x],j)==lasthigh) {k=ExtBarLeft_[x]; continue;}
               if (iHigh(NULL,GrossPeriod_[x],j)>lasthigh && k>0) {frh=false; break;}
               if (iHigh(NULL,GrossPeriod_[x],j)<lasthigh) k--;
              }

            if (frh)
              {
               k=ExtBarRight_[x];
               for (j=lasthighpos-1;(j>0 && k>0);j--)
                 {
                  if (j==1 && k>1) {frh=false; break;}
                  if (iHigh(NULL,GrossPeriod_[x],j)==lasthigh) {k=ExtBarRight_[x]; continue;}
                  if (iHigh(NULL,GrossPeriod_[x],j)>lasthigh && k>0) {frh=false; break;}
                  if (iHigh(NULL,GrossPeriod_[x],j)<lasthigh) k--;
                 }
              }

            if (frh) HB[lasthighpos]=lasthigh;
            frh=false;
           }
         else
           {
            if (ExtZZ)
              {
               if (lasthigh<iHigh(NULL,GrossPeriod_[x],i)) {lasthigh=iHigh(NULL,GrossPeriod_[x],i); lasthighpos=i;}
              }
            else
              {
               if (lasthigh<=iHigh(NULL,GrossPeriod_[x],i)) {lasthigh=iHigh(NULL,GrossPeriod_[x],i); lasthighpos=i;}
              }
           }
        }

     }    

   return (0);
  }
//+------------------------------------------------------------------+
//|    . .                              |
//+------------------------------------------------------------------+

//+------------------------------------------------------------------+
//| . .                                                |
//+------------------------------------------------------------------+
int Weeding(double& LB[],double& HB[],int x) // 
  {
   int i, lastlowpos, lasthighpos, firstbar, bar;
   double lastlow, lasthigh, curlow=0, curhigh=0;
   bool frl=false, frh=false;

   bar=ArraySize(LB);
   
   lasthigh=-1; lastlow=-1; lastlowpos=0; lasthighpos=0;
   if (tlastfractal_[x]>0)
     {
      firstbar=iBarShift(NULL,GrossPeriod_[x],tlastfractal_[x],false)+1;
      for (i=firstbar;i>bar-1;i++)
        {
         if (!frl) {if (LB[i]>0) frl=true;}
         if (!frh) {if (HB[i]>0) frh=true;}
         if (frl && frh) {firstbar=i; break;}
        }
     }
   else firstbar=bar-1;

   for(i=firstbar; i>0; i--)
     {
      if (LB[i]>0) {curlow=iLow(NULL,GrossPeriod_[x],i);} else {curlow=0;}
      if (HB[i]>0) {curhigh=iHigh(NULL,GrossPeriod_[x],i);} else {curhigh=0;}

      if(curlow==0 && curhigh==0) continue;

      if(curhigh!=0)
        {
         if(lasthigh>0) 
           {
            if (ExtZZ)
              {
               if(lasthigh<curhigh) {HB[lasthighpos]=0;} else {HB[i]=0;}
              }
            else
              {
               if(lasthigh<=curhigh) {HB[lasthighpos]=0;} else {HB[i]=0;}
              }
           }

         if (ExtZZ)
           {
            if(lasthigh<curhigh || lasthigh<0)
              {
               lasthigh=curhigh;
               lasthighpos=i;
              }
           }
         else
           {
            if(lasthigh<=curhigh || lasthigh<0)
              {
               lasthigh=curhigh;
               lasthighpos=i;
              }
           }

         lastlow=-1;
        }

      if(curlow!=0)
        {
         if(lastlow>0)
           {
            if (ExtZZ)
              {
               if(lastlow>curlow) {LB[lastlowpos]=0;} else {LB[i]=0;}
              }
            else
              {
               if(lastlow>=curlow) {LB[lastlowpos]=0;} else {LB[i]=0;}
              }
           }

         if (ExtZZ)
           {
            if(curlow<lastlow||lastlow<0)
              {
               lastlow=curlow;
               lastlowpos=i;
              } 
           }
         else
           {
            if(curlow<=lastlow||lastlow<0)
              {
               lastlow=curlow;
               lastlowpos=i;
              } 
           }

         lasthigh=-1;
        }
     } 

   return (0);
  }
//+------------------------------------------------------------------+
//| . .                                                 |
//+------------------------------------------------------------------+

//+------------------------------------------------------------------+
//|        . . |
//+------------------------------------------------------------------+
void _stringtointarray (string str, int& arr[], int x)
  {
   int i,j,k=0;
   for (i=0;i<x;i++)
     {
      j=StringFind(str,",",k);
      if (j<0) {arr[i]=StrToInteger(StringSubstr(str,k)); break;}
      arr[i]=StrToInteger(StringSubstr(str,k,j-k));
      k=j+1;
     }
  }
//+------------------------------------------------------------------+
//|        ..   |
//+------------------------------------------------------------------+

//+------------------------------------------------------------------+
//|        . . |
//+------------------------------------------------------------------+
void _stringtocolorarray (string str, int& arr[], int x)
  {
   int i,j,k=0;
   for (i=0;i<x;i++)
     {
      j=StringFind(str,",",k);
      if (j<0) {arr[i]=fStrToColor(StringSubstr(str,k)); break;}
      arr[i]=fStrToColor(StringSubstr(str,k,j-k));
      k=j+1;
     }
  }
//+------------------------------------------------------------------+
//|        ..   |
//+------------------------------------------------------------------+

//+------------------------------------------------------------------+
//|     1  0      |
//| . .                                                 |
//+------------------------------------------------------------------+
void Shift_elements (double& arr[], double& arr1[])
  {
   int i,j;

   j=ArraySize(arr)-1;
   for (i=j;i>0;i--)
     {
      arr[i]=arr[i-1];
      arr1[i]=arr1[i-1];
     }
   arr[0]=0;
   arr1[0]=0;
  }
//-------------------------------------------------------------------+
//|     1  0      |
//| . .                                                  |
//-------------------------------------------------------------------+

//+------------------------------------------------------------------+
//|         0|
//| .                                                          |
//+------------------------------------------------------------------+
void arr_resize (double& arr[], double& arr1[], int size, int x)
  {
   if (GrossPeriod_[x]>0)
     {
      ArrayResize(arr,size); ArrayResize(arr1,size);
      ArrayInitialize(arr,0); ArrayInitialize(arr1,0);
     }
  }
//+------------------------------------------------------------------+
//|         0|
//| .                                                           |
//+------------------------------------------------------------------+


//+------------------------------------------------------------------+
//|    . .                            |
//|   Integer.  http://forum.mql4.com/ru/7134          |
//+------------------------------------------------------------------+
color fStrToColor(string aName)
  {
 
   color tColor[]={  Black, DarkGreen, DarkSlateGray, Olive, Green, Teal, Navy, Purple, 
                     Maroon, Indigo, MidnightBlue, DarkBlue, DarkOliveGreen, SaddleBrown, 
                     ForestGreen, OliveDrab, SeaGreen, DarkGoldenrod, DarkSlateBlue, 
                     Sienna, MediumBlue, Brown, DarkTurquoise, DimGray, LightSeaGreen, 
                     DarkViolet, FireBrick, MediumVioletRed, MediumSeaGreen, Chocolate, 
                     Crimson, SteelBlue, Goldenrod, MediumSpringGreen, LawnGreen, 
                     CadetBlue, DarkOrchid, YellowGreen, LimeGreen, OrangeRed, DarkOrange, 
                     Orange, Gold, Yellow, Chartreuse, Lime, SpringGreen, Aqua, DeepSkyBlue, 
                     Blue, Magenta, Red, Gray, SlateGray, Peru, BlueViolet, LightSlateGray, 
                     DeepPink, MediumTurquoise, DodgerBlue, Turquoise, RoyalBlue, SlateBlue, 
                     DarkKhaki, IndianRed, MediumOrchid, GreenYellow, MediumAquamarine, 
                     DarkSeaGreen, Tomato, RosyBrown, Orchid, MediumPurple, PaleVioletRed, 
                     Coral, CornflowerBlue, DarkGray, SandyBrown, MediumSlateBlue, Tan, 
                     DarkSalmon, BurlyWood, HotPink, Salmon, Violet, LightCoral, SkyBlue, 
                     LightSalmon, Plum, Khaki, LightGreen, Aquamarine, Silver, LightSkyBlue, 
                     LightSteelBlue, LightBlue, PaleGreen, Thistle, PowderBlue, PaleGoldenrod, 
                     PaleTurquoise, LightGray, Wheat, NavajoWhite, Moccasin, LightPink, 
                     Gainsboro, PeachPuff, Pink, Bisque, LightGoldenrod, BlanchedAlmond, 
                     LemonChiffon, Beige, AntiqueWhite, PapayaWhip, Cornsilk, LightYellow, 
                     LightCyan, Linen, Lavender, MistyRose, OldLace, WhiteSmoke, Seashell, 
                     Ivory, Honeydew, AliceBlue, LavenderBlush, MintCream, Snow, White
                  };  
   string tName[]={   "Black", "DarkGreen", "DarkSlateGray", "Olive", "Green", "Teal", "Navy", "Purple", 
                     "Maroon", "Indigo", "MidnightBlue", "DarkBlue", "DarkOliveGreen", "SaddleBrown", 
                     "ForestGreen", "OliveDrab", "SeaGreen", "DarkGoldenrod", "DarkSlateBlue", 
                     "Sienna", "MediumBlue", "Brown", "DarkTurquoise", "DimGray", "LightSeaGreen", 
                     "DarkViolet", "FireBrick", "MediumVioletRed", "MediumSeaGreen", "Chocolate", 
                     "Crimson", "SteelBlue", "Goldenrod", "MediumSpringGreen", "LawnGreen", 
                     "CadetBlue", "DarkOrchid", "YellowGreen", "LimeGreen", "OrangeRed", "DarkOrange", 
                     "Orange", "Gold", "Yellow", "Chartreuse", "Lime", "SpringGreen", "Aqua", "DeepSkyBlue", 
                     "Blue", "Magenta", "Red", "Gray", "SlateGray", "Peru", "BlueViolet", "LightSlateGray", 
                     "DeepPink", "MediumTurquoise", "DodgerBlue", "Turquoise", "RoyalBlue", "SlateBlue", 
                     "DarkKhaki", "IndianRed", "MediumOrchid", "GreenYellow", "MediumAquamarine", 
                     "DarkSeaGreen", "Tomato", "RosyBrown", "Orchid", "MediumPurple", "PaleVioletRed", 
                     "Coral", "CornflowerBlue", "DarkGray", "SandyBrown", "MediumSlateBlue", "Tan", 
                     "DarkSalmon", "BurlyWood", "HotPink", "Salmon", "Violet", "LightCoral", "SkyBlue", 
                     "LightSalmon", "Plum", "Khaki", "LightGreen", "Aquamarine", "Silver", "LightSkyBlue", 
                     "LightSteelBlue", "LightBlue", "PaleGreen", "Thistle", "PowderBlue", "PaleGoldenrod", 
                     "PaleTurquoise", "LightGray", "Wheat", "NavajoWhite", "Moccasin", "LightPink", 
                     "Gainsboro", "PeachPuff", "Pink", "Bisque", "LightGoldenrod", "BlanchedAlmond", 
                     "LemonChiffon", "Beige", "AntiqueWhite", "PapayaWhip", "Cornsilk", "LightYellow", 
                     "LightCyan", "Linen", "Lavender", "MistyRose", "OldLace", "WhiteSmoke", "Seashell", 
                     "Ivory", "Honeydew", "AliceBlue", "LavenderBlush", "MintCream", "Snow", "White"
                  };

   aName=StringTrimLeft(StringTrimRight(aName));      
   for(int i=0;i<ArraySize(tName);i++)
     {
      if(aName==tName[i])return(tColor[i]);
     }

  return(Red);                                     
                
 }
//+------------------------------------------------------------------+
//|    . .                             |
//|   Integer.  http://forum.mql4.com/ru/7134          |
//+------------------------------------------------------------------+

